{-# LANGUAGE LambdaCase #-}

module WebSocket.AllChat (broadCastAllChatMessage) where

import BroadcastUserData (MonadBroadcast (..))
import ClassyPrelude
import Data.Aeson (encode)
import Types.User (clientToUser)
import Types.WebSocketMessages.WebSocketMessages (AllChatMessageIncoming (..), AllChatMessageOutgoing (AllChatMessageOutgoing))
import WebSocket.MonadWebSocketSession (MonadWebSocketSession (getClient))

broadCastAllChatMessage :: (MonadBroadcast m, MonadWebSocketSession m) => AllChatMessageIncoming -> m ()
broadCastAllChatMessage AllChatMessageIncoming {content = message} = do
  getClient >>= \case
    Nothing -> return ()
    Just client -> do
      let broadCastValue = AllChatMessageOutgoing message (clientToUser client)
      broadCastToClients $ (decodeUtf8 . toStrict . encode) broadCastValue
